<!DOCTYPE html>
<html>
<body>
<script>
var a="var-o";

function fun1()
  {
    var a="var1"
    document.write("inside fun1: "+this.a);
    document.write("<br>inside fun1: "+a); 
    document.write("<br>");
    var fun12 = () =>
    { 
      a="arrow var";
      document.write("<br>before fun12 call");
      document.write("<br>inside fun12: "+this.a);
      document.write("<br>inside fun12: "+a); 
      document.write("<br>");
      var fun13 = () =>
      { 
        a="arrow2 var";
        document.write("<br>before fun13 call");
        document.write("<br>inseide fun13: "+this.a);
        document.write("<br>inside fun13: "+a); 
        document.write("<br>");
      }
    fun13();
    }
    fun12();
    document.write("<br>after fun12 call");
    document.write("<br>inside fun12: "+this.a);
    document.write("<br>inside fun12: "+a); 
    document.write("<br>");
  }
fun1();
var fun2 = () =>
  {
  var a="var2";
  document.write("<br>");
  document.write("<br>after fun2 call");
  document.write("<br>inside fun2: "+this.a);
  document.write("<br>inside fun2: "+a);
  document.write("<br>");
  function fun21()
    {
      document.write("<br>");
      document.write("<br>after fun21 call");
      document.write("<br>inside fun21: "+this.a);
    }
  document.write("<br>");
  document.write("before fun21 call");
  document.write("<br>inside fun21: "+this.a);
  fun21();  
}
document.write("<br>before fun2 call");
document.write("<br>inside fun2: "+this.a);
document.write("<br>inside fun2: "+a);
fun2();
document.write("<br>");
var b=
  {
    k:"obj val",
    L: function()
    {
      var B="var-a";
      document.write("<br>inside obj: "+B);
    },
}
document.write("<br>");
document.write("before B.L call");
document.write("<br>inside fun L: "+b.k);
b.L();
document.write("<br>");
fun3=function()
  {  
    a="var3";
    var M=
      {
        x:"obj val",
      }
    document.write("after fun3 call");
    document.write("<br>");
    document.write("<br>inside obj M:"+M.x);
    document.write("<br>inside fun3: "+this.a);
    document.write("<br>inside fun3: "+a);
  }
document.write("<br>");
document.write("before fun3 call");
document.write("<br>fun3: "+this.a);
document.write("<br>fun3: "+a);
fun3();
document.write("<br>");

//create 
let k=
{
  m:"cobj1",
  n:"cobj2",
};
var f=Object.create(k);
f.m="hi";
f.m="cobj3";
k.l="cobj4";
f.o="cobj5";
document.write("<br>object k :",k.m);
document.write("<br>object k:",k.l);
document.write("<br>new object f:",f.m);
document.write("<br>");

//keys
document.write("<br> keys of k :",Object.keys(k));
document.write("<br> keys of f :",Object.keys(f));
document.write("<br> keys of k :",Object.values(k));
document.write("<br> keys of f :",Object.values(f));
console.log(k);
document.write("<br>");

//entries
var en= Object.entries(k);
document.write("<br> k entries : "+en);
console.log(en);
document.write("<br>f entries : ",Object.entries(f));
console.log(Object.entries(f));
console.log("f before :"+f);

//assign
var an=Object.assign(f,k);
document.write("<br>assign :"+an);
console.log("an :",an);
console.log("f :",f);

//spread
document.write("<br>spread :"+{...k, ...f});
console.log({...k, ...f, ...b});
document.write("<br>spread2"+{...k});

let fun=function(...q){
  console.log(q);
}
fun(1,2,3,4,5,6,7,8,9,10);

//freeze
var fre=
{
  1:"a",
  2:"b",
  3:"c",
}
var free=Object.freeze(fre);
free[1]="aa";//won't effect object
fre[1]="ab";//won't effect object
free[4]="d";//won't effect object
delete free[1];//won't effect object
console.log(free);

//seal
var sea=
{
  1:"aa",
  2:"bb",
  3:"cc",
}
var sea1=Object.seal(sea);//latest modification will store in propery
sea1[1]="ab";
sea[1]="aba";
sea1[4]="dd";//won't effect object
delete sea1[1];//won't effect object
console.log(sea1);

//prototype
var j=['chandu','venky','teja'];
document.write(Object.getPrototypeOf(j));
console.log(Object.getPrototypeOf(j));

//checking prototype of arrays and objects
console.log(Object.getPrototypeOf(j) === Array.prototype);
</script>
</body>
</html>
